/* SPDX-License-Identifier: BSD-2 */

#ifndef _hashmap_h
#define _hashmap_h

#define MAP_OK            0
#define MAP_OMEM         -1
#define MAP_FULL         -2
#define MAP_MISSING      -3
#define MAP_BAD_ARGS     -4
#define MAP_ALREADY_USED -5

extern void *hashmap_new(void);
extern void hashmap_free(void *map);

extern int hashmap_put(void *map, char *key, char *val);
extern int hashmap_get(void *map, char *key, char **ret_val);
extern int hashmap_del(void *map, char *key);

#endif
